<template>
  <v-combobox
    :value="selectedColumns"
    :items="allColumns"
    :label="$t('columnsToShow')"
    outlined
    multiple
    chips
    small-chips
    @input="onChangeSelectedColumns"
  />
</template>

<script>
  import { sortBy } from 'lodash'
  import {
    setSelectedExpensesColumns,
    getSelectedExpensesColumns,
    isSetSelectedExpensesColumns,
  } from '@/services/local-storage'

  export default {
    name: 'ColumnsToShow',
    props: {
      value: {
        type: Array,
        required: true,
      },
      defaultColumns: {
        type: Array,
        required: true,
      },
      sortedColumns: {
        type: Array,
        required: true,
      },
    },
    data () {
      return {
        selectedColumns: [],
        allColumns: this.sortColumnsByTextKey(this.value),
      }
    },
    created () {
      const selectedColumns = this.getSelectedColumns(this.allColumns)
      this.selectedColumns = this.sortSelectedColumns(selectedColumns)
      this.onChangeSelectedColumns(this.selectedColumns)
    },
    methods: {
      sortColumnsByTextKey (columns) {
        return sortBy(columns, ['text'])
      },
      sortSelectedColumns (selectedColumns) {
        const sortedSelectedColumns = []
        this.sortedColumns.forEach(sortedColumn => {
          const foundColumn = selectedColumns.find(selectedColumn =>
            selectedColumn.value === sortedColumn,
          )
          if (foundColumn) {
            sortedSelectedColumns.push(foundColumn)
          }
        })
        return sortedSelectedColumns
      },
      getSelectedColumns (allColumns) {
        const selectedColumns = isSetSelectedExpensesColumns()
          ? getSelectedExpensesColumns()
          : this.defaultColumns

        return allColumns.filter(availableColumn => {
          return selectedColumns.includes(availableColumn.value)
        })
      },
      onChangeSelectedColumns (columns) {
        this.$emit('input', this.sortSelectedColumns(columns))
        setSelectedExpensesColumns(columns.map(column => column.value))
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          columnsToShow: 'Colunas para exibir',
        },
        'en-US': {
          columnsToShow: 'Columns to show',
        },
      },
    },
  }
</script>
